diff --git a/data/bullets.json b/data/bullets.json
index d15f2bcca..cd412c05d 100644
--- a/data/bullets.json
+++ b/data/bullets.json
@@ -611,6 +611,11 @@
         "Type": "Directional",
         "Sprites": "rocket_blue"
       },
+      "Trail": {
+        "Particle": "smoke_trail",
+        "Width": 0,
+        "TicksPerEmit": 4
+      },
       "ShadowSize": [4, 3],
       "Speed": 250,
       "Friction": -9,
diff --git a/data/particles.json b/data/particles.json
index f73bd3822..c88dcc4f3 100644
--- a/data/particles.json
+++ b/data/particles.json
@@ -205,6 +205,15 @@
       },
       "Range": 100
     },
+    {
+      "Name": "smoke_trail",
+      "Pic": {
+        "Type": "Animated",
+        "Sprites": "smoke_trail",
+        "TicksPerFrame": 7
+      },
+      "Range": 34
+    },
     {
       "Name": "explosion_small",
       "Pic": {
diff --git a/graphics/smoke_trail.txt b/graphics/smoke_trail.txt
new file mode 100644
index 000000000..651f94d55
--- /dev/null
+++ b/graphics/smoke_trail.txt
@@ -0,0 +1,4 @@
+Adapted from Items and elements
+By GrafxKid
+https://opengameart.org/content/items-and-elements
+http://creativecommons.org/publicdomain/zero/1.0/
\ No newline at end of file
diff --git a/graphics/smoke_trail_16x16.png b/graphics/smoke_trail_16x16.png
new file mode 100644
index 000000000..8c0c56d9f
Binary files /dev/null and b/graphics/smoke_trail_16x16.png differ
diff --git a/src/cdogs/actors.c b/src/cdogs/actors.c
index 9d6991d12..dd4d50ca2 100644
--- a/src/cdogs/actors.c
+++ b/src/cdogs/actors.c
@@ -1664,7 +1664,7 @@ static void ActorAddBloodSplatters(
 		AddParticle ap;
 		memset(&ap, 0, sizeof ap);
 		ap.Pos = a->Pos;
-		ap.Angle = -1;
+		ap.Angle = NAN;
 		ap.Z = 10;
 		ap.Vel = vel;
 		ap.Mask = ActorGetCharacter(a)->Class->BloodColor;
diff --git a/src/cdogs/bullet_class.c b/src/cdogs/bullet_class.c
index a870b77a5..473c9a7f0 100644
--- a/src/cdogs/bullet_class.c
+++ b/src/cdogs/bullet_class.c
@@ -136,7 +136,7 @@ static struct vec2 SeekTowards(
 
 
 static void FireGuns(const TMobileObject *obj, const CArray *guns);
-static void AddTrail(const TMobileObject *obj);
+static void AddTrail(TMobileObject *obj, const int ticks);
 typedef struct
 {
 	HitType Type;
@@ -369,7 +369,7 @@ bool BulletUpdate(struct MobileObject *obj, const int ticks)
 		}
 	}
 
-	AddTrail(obj);
+	AddTrail(obj, ticks);
 
 	return true;
 }
@@ -384,31 +384,40 @@ static void FireGuns(const TMobileObject *obj, const CArray *guns)
 			true, false);
 	}
 }
-static void AddTrail(const TMobileObject *obj)
+static void AddTrail(TMobileObject *obj, const int ticks)
 {
 	const struct vec2 vel = svec2_subtract(obj->thing.Pos, obj->thing.LastPos);
-	if (obj->bulletClass->Trail.P == NULL || svec2_is_zero(vel))
+	if (obj->bulletClass->Trail.P == NULL)
 	{
 		return;
 	}
-	GameEvent s = GameEventNew(GAME_EVENT_ADD_PARTICLE);
-	s.u.AddParticle.Class = obj->bulletClass->Trail.P;
-	s.u.AddParticle.Pos = svec2_scale(svec2_add(
-		obj->thing.Pos, obj->thing.LastPos
-	), 0.5f);
-	s.u.AddParticle.Z = obj->z;
-	s.u.AddParticle.Angle = svec2_angle(vel) + MPI_2;
+	AddParticle ap;
+	memset(&ap, 0, sizeof ap);
+	ap.Pos = svec2_scale(svec2_add(obj->thing.Pos, obj->thing.LastPos), 0.5f);
+	ap.Z = obj->z / Z_FACTOR;
+	ap.Angle = svec2_angle(vel) + MPI_2;
+	ap.Mask = colorWhite;
 	if (obj->bulletClass->Trail.P->Type == PARTICLE_PIC)
 	{
-		const Pic *pic = CPicGetPic(
-			&obj->bulletClass->Trail.P->u.Pic, DIRECTION_UP);
-		const struct vec2 trailSize = svec2(
-			obj->bulletClass->Trail.Width, svec2_length(vel)
-		);
-		s.u.AddParticle.DrawScale = svec2_divide(
-			trailSize, svec2_assign_vec2i(pic->size));
+		const CPic *cpic = &obj->bulletClass->Trail.P->u.Pic;
+		const Pic *pic = CPicGetPic(cpic, 0);
+		if (obj->bulletClass->Trail.Width > 0)
+		{
+			const struct vec2 trailSize = svec2(
+				obj->bulletClass->Trail.Width, svec2_length(vel)
+			);
+			ap.DrawScale = svec2_divide(
+				trailSize, svec2_assign_vec2i(pic->size));
+		}
+	}
+	if (obj->trail.ticksPerEmit > 0 && ticks > 0)
+	{
+		EmitterUpdate(&obj->trail, &ap, ticks);
+	}
+	else
+	{
+		EmitterStart(&obj->trail, &ap);
 	}
-	GameEventsEnqueue(&gGameEvents, s);
 }
 typedef struct
 {
@@ -693,6 +702,7 @@ static void LoadBullet(
 		}
 		b->Trail.Width = 1.0f;
 		LoadFloat(&b->Trail.Width, trail, "Width");
+		LoadInt(&b->Trail.TicksPerEmit, trail, "TicksPerEmit");
 	}
 	LoadVec2i(&b->ShadowSize, node, "ShadowSize");
 	LoadInt(&b->Delay, node, "Delay");
@@ -792,10 +802,11 @@ static void LoadBullet(
 		b->Falling.FallsDown ? "true" : "false",
 		b->Falling.DestroyOnDrop ? "true" : "false");
 	LOG(LM_MAP, LL_DEBUG,
-		"...dropGuns(%d) seekFactor(%d) erratic(%s) trail(%s@%f)...",
+		"...dropGuns(%d) seekFactor(%d) erratic(%s) trail(%s@%f per %d)...",
 		(int)b->Falling.DropGuns.size, b->SeekFactor,
 		b->Erratic ? "true" : "false",
-		b->Trail.P != NULL ? b->Trail.P->Name : "", b->Trail.Width);
+		b->Trail.P != NULL ? b->Trail.P->Name : "", b->Trail.Width,
+		b->Trail.TicksPerEmit);
 	LOG(LM_MAP, LL_DEBUG,
 		"...outOfRangeGuns(%d) hitGuns(%d) proximityGuns(%d)",
 		(int)b->OutOfRangeGuns.size,
@@ -933,6 +944,10 @@ void BulletAdd(const NAddBullet add)
 	obj->z = add.MuzzleHeight;
 	obj->dz = add.Elevation;
 
+	EmitterInit(
+		&obj->trail, obj->bulletClass->Trail.P,
+		svec2_zero(), 0, 0, 0, 0, 0, 0, obj->bulletClass->Trail.TicksPerEmit);
+
 	obj->thing.Vel = svec2_scale(
 		Vec2FromRadians(add.Angle),
 		RAND_FLOAT(obj->bulletClass->SpeedLow, obj->bulletClass->SpeedHigh));
@@ -1016,7 +1031,7 @@ void PlayHitSound(const HitSounds *h, const HitType t, const struct vec2 pos)
 void BulletDestroy(TMobileObject *obj)
 {
 	CASSERT(obj->isInUse, "Destroying not-in-use bullet");
-	AddTrail(obj);
+	AddTrail(obj, 0);
 	MapRemoveThing(&gMap, &obj->thing);
 	obj->isInUse = false;
 }
diff --git a/src/cdogs/bullet_class.h b/src/cdogs/bullet_class.h
index 569518059..01ad1f7ed 100644
--- a/src/cdogs/bullet_class.h
+++ b/src/cdogs/bullet_class.h
@@ -65,6 +65,7 @@ typedef struct
 	{
 		const ParticleClass *P;
 		float Width;
+		int TicksPerEmit;
 	} Trail;
 	struct vec2i ShadowSize;
 	int Delay;	// number of frames before moving
diff --git a/src/cdogs/emitter.c b/src/cdogs/emitter.c
index 604731acf..a3bead06e 100644
--- a/src/cdogs/emitter.c
+++ b/src/cdogs/emitter.c
@@ -54,18 +54,20 @@ void EmitterStart(Emitter *em, const AddParticle *data)
 
 	// TODO: single event multiple particles
 	GameEvent e = GameEventNew(GAME_EVENT_ADD_PARTICLE);
+	e.u.AddParticle = *data;
 	e.u.AddParticle.Pos = p;
-	e.u.AddParticle.Z = data->Z * Z_FACTOR;
+	e.u.AddParticle.Z *= Z_FACTOR;
 	e.u.AddParticle.Class = em->p;
 	const float speed = RAND_FLOAT(em->minSpeed, em->maxSpeed);
 	const struct vec2 baseVel = svec2_rotate(
 		svec2(0, speed), RAND_FLOAT(0, MPI * 2));
 	e.u.AddParticle.Vel = svec2_add(data->Vel, baseVel);
-	e.u.AddParticle.Angle =
-		data->Angle >= 0 ? data->Angle : RAND_FLOAT(0, MPI * 2);
+	if (isnan(data->Angle))
+	{
+		e.u.AddParticle.Angle = RAND_FLOAT(0, MPI * 2);
+	}
 	e.u.AddParticle.DZ = RAND_INT(em->minDZ, em->maxDZ);
 	e.u.AddParticle.Spin = RAND_DOUBLE(em->minRotation, em->maxRotation);
-	e.u.AddParticle.Mask = data->Mask;
 	GameEventsEnqueue(&gGameEvents, e);
 }
 
diff --git a/src/cdogs/objs.h b/src/cdogs/objs.h
index 12925be1d..c0a198271 100644
--- a/src/cdogs/objs.h
+++ b/src/cdogs/objs.h
@@ -71,7 +71,6 @@ typedef struct
 	int counter;
 	Thing thing;
 	Emitter damageSmoke;
-	int damageSmokeCounter;
 	bool isInUse;
 } TObject;
 
@@ -89,6 +88,7 @@ typedef struct MobileObject
 	// Don't trigger special effects too frequently
 	int specialLock;
 	Thing thing;
+	Emitter trail;
 	bool isInUse;
 } TMobileObject;
 typedef int (*MobObjUpdateFunc)(TMobileObject *, int);
